

#include "pce.h"
#include "m6502.h"

extern int		ds_nBits;
extern int		ds_nChannels;
extern int		ds_nSampleRate;
extern int		ds_nLockLatency;
extern unsigned	ds_dwLockSize;
extern unsigned	ds_dwBufferSize;
extern int		bActiveApp;
//extern int		ds_CoopMode;


int InitDSound();
int StartSound(void);
int ReleaseDSound(void);
int ReleaseSoundBuffer(void);
int StopSound(void);

extern IO	io;
extern M6502	*M2;

extern int FPS;

static int bInitialized = 0;
static void WriteBuffer(unsigned short *buf, int ch, unsigned dwSize);

static inline int max(int a,int b)
{
if(b>a) return b;
return a;
}



#define SOUND_BUF_MS	200
unsigned	dwOldPos[6];
unsigned short	sbuf[6][44100*SOUND_BUF_MS/1000*sizeof(unsigned short)*2];
unsigned short	obuf[44100*SOUND_BUF_MS/1000*sizeof(unsigned short)*2];
unsigned	CycleOld;
extern int	BaseClock;


int InitSound(int Mode)
    /* Returns 1 on success, 0 otherwise. Mode=0 to skip     */
    /* initialization (will be silent), Mode=1 to use Adlib, */
    /* Mode=2..7 to use SoundBlaster wave synthesis.         */
{
	

	if (Mode == 0)
		return 1;

	int	bRet;

	memset(dwOldPos,0,4*6);
	memset(&sbuf[0][0],0, 44100*SOUND_BUF_MS/1000*sizeof(unsigned short)*2*6);
	bRet = InitDSound();

	if (bRet)
	{
		bInitialized = 1;
	}

	return bRet;
}

void TrashSound(void)                   /* Shut down sound  */
{
	

	if (!bInitialized)
		return;
	bInitialized = 0;

	StopSound();
	ReleaseDSound();
}
void write_psg(int ch)
{
	unsigned	Cycle;
	unsigned	dwNewPos;

	if (!bInitialized)
		return;
   //if(ch==2 || ch==3) return; // solo 4 canales
	if ((int)((unsigned)M2->User - CycleOld) < 0)
		CycleOld = (unsigned)M2->User;
	Cycle = (unsigned)M2->User - CycleOld;
	dwNewPos = (unsigned)ds_nSampleRate/25*(Cycle/2)/(BaseClock/45);
	if (dwNewPos > (unsigned)ds_nSampleRate*SOUND_BUF_MS/1000)
	{
//		TRACE("sound buffer overrun\n");
		dwNewPos = ds_nSampleRate*SOUND_BUF_MS*3/4/1000;
	}
	if (dwNewPos > dwOldPos[ch])
	{
	

		WriteBuffer(&sbuf[ch][dwOldPos[ch]*ds_nChannels], ch, (dwNewPos-dwOldPos[ch])*ds_nChannels);
		dwOldPos[ch] = dwNewPos;
	}
}

static int mseq(unsigned *rand_val)
{
	if (*rand_val & 0x00080000)
	{
		*rand_val = ((*rand_val ^ 0x0004) << 1) + 1;
		return 1;
	}
	else
	{
		*rand_val <<= 1;
		return 0;
	}
}

void inline snd_copy(short *d,short *s,int samples)
{
int n;
for(n=0;n<samples;n++)
	{
	*d++ +=*s++;
	}
}

void inline snd_mix(short *d,short *s,int samples)
{
int n;
volatile short v,v2;
for(n=0;n<samples;n+=2)
	{
	v=*s++;v2=*s++;
	if(v<-128) v=-128; if(v>127) v=127; // limita el audio a 8 bits con signo
	if(v2<-128) v2=-128; if(v2>127) v2=127;
	v<<=8;v2<<=8;
	*d++=v;*d++=v2;*d++=v;*d++=v2; // convierte de 22Khz a 44Khz
	}
}
void WriteSoundData(unsigned short *buf, int ch, unsigned dwSize)
{
	unsigned	dwNewPos;

//	if(ch==2 || ch==3) return; // solo 4 canales


	dwNewPos = dwSize/ds_nChannels;
	if (dwOldPos[ch] < dwNewPos)
		WriteBuffer(&sbuf[ch][dwOldPos[ch]*ds_nChannels], ch, (dwNewPos-dwOldPos[ch])*ds_nChannels);
	CycleOld = (unsigned)M2->User;
	
	if(ch==0) memcpy(obuf, sbuf[ch], dwSize*sizeof(unsigned short));
	else snd_copy(obuf, sbuf[ch], dwSize);
	if(ch==5) snd_mix(buf, obuf, dwSize);
	if (dwOldPos[ch] >= dwNewPos)
	{
		if (dwOldPos[ch] >= (unsigned)ds_nSampleRate*SOUND_BUF_MS/(1000*100/95))
		{
			unsigned	size = ds_nSampleRate*SOUND_BUF_MS/4/1000;
			memcpy(sbuf[ch], sbuf[ch]+dwNewPos*ds_nChannels, size*sizeof(unsigned short)*ds_nChannels);
			dwOldPos[ch] = size;
		}
		else
		{
			memcpy(sbuf[ch], sbuf[ch]+dwNewPos*ds_nChannels, (dwOldPos[ch]-dwNewPos)*sizeof(unsigned short )*ds_nChannels);
			dwOldPos[ch] = dwOldPos[ch]-dwNewPos;
		}
	}
	else
	{dwOldPos[ch] = 0;}
	
}


void WriteBuffer(unsigned short *buf, int ch, unsigned dwSize)
{
	int i;
//#ifdef _DEBUG
//	if (ch == 0)
//		debug_dump("%08X-%08X\n", buf-sbuf[ch], buf-sbuf[ch]+dwSize);
//#endif
	static unsigned	n[6] = {0,0,0,0,0,0};
#define	N	32
#define DESPL_S 22
	static unsigned	k[6] = {0,0,0,0,0,0};
	static unsigned	t;
//	static int		bInit = 1;
	static unsigned	r[6];
	static unsigned	rand_val[6] = {0,0,0,0,0x51F631E4,0x51F631E4};
	static unsigned short		wave[32];
	int polarity[2],polarity2[2];
	/* a*2^(b*x) */
	/* a = 400, b = log2(16384/a), x = 0.0 ~ 1.0 */
	static int		vol_tbl[32] =
	{
		100,451,508,573,646,728,821,925,
		1043,1175,1325,1493,1683,1898,2139,2411,
		2718,3064,3454,3893,4388,4947,5576,6285,
		7085,7986,9002,10148,11439,12894,14535,16384,
	};
	unsigned	dwPos;
	int		lvol, rvol;
	unsigned	Tp;

	if (!(io.PSG[ch][4]&0x80))
	{
		n[ch] = k[ch] = 0;
		for (dwPos = 0; dwPos < dwSize; dwPos++)
			*buf++ = 0;
		return;
	}

//	TRACE("buf=%08X,size=%08X\n", buf, dwSize);

	if (io.PSG[ch][4]&0x40)
	{
//		TRACE("wave=%d\n", io.wave[ch][0]);
		wave[0] = ((short)io.wave[ch][0]-16)*702;
		if (ds_nChannels == 2)
		{
			lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = (((int)(short)wave[0])*vol_tbl[lvol])>>DESPL_S;
			rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
			rvol = rvol-60;
			if (rvol < 0) rvol = 0;
			rvol = (((int)(short)wave[0])*vol_tbl[rvol])>>DESPL_S;
			for (dwPos = 0; dwPos < dwSize; dwPos += 2)
			{
				*buf++ = (int)lvol;
				*buf++ = (int)rvol;
			}
		}
		else
		{
			lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
						max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = (((int)(short)wave[0])*vol_tbl[lvol])>>DESPL_S;
			for (dwPos = 0; dwPos < dwSize; dwPos++)
			{
				*buf++ = (int)lvol;
			}
		}
	}
	else
	{
//for (dwPos = 0; dwPos < dwSize; dwPos++)
//	*buf++ = 0;
//return;
		if (ch >= 4 && (io.PSG[ch][7]&0x80))
		{
			unsigned Np = (io.PSG[ch][7]&0x1F);
			if (ds_nChannels == 2)
			{
			volatile int r_value,l_value;
				lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
				lvol = lvol-60;
				if (lvol < 0) lvol = 0;
				lvol = vol_tbl[lvol];
				rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
				rvol = rvol-60;
				if (rvol < 0) rvol = 0;
				rvol = vol_tbl[rvol];
				l_value=(10*702*lvol)>>DESPL_S;
				r_value=(10*702*rvol)>>DESPL_S;
               
			    polarity[0]=l_value;polarity[1]=-l_value;
				polarity2[0]=r_value;polarity2[1]=-r_value;
				for (dwPos = 0; dwPos < dwSize; dwPos += 2)
				{
					k[ch] += 3000+(Np<<9);
					t = k[ch] / (unsigned)ds_nSampleRate;
					if (t >= 1)
					{
						r[ch] = mseq(&rand_val[ch]);
						k[ch] -= ds_nSampleRate*t;
					}
					//*buf++ = (int)((r[ch] ? 10*702 : -10*702)*lvol/16384);
					//*buf++ = (int)((r[ch] ? 10*702 : -10*702)*rvol/16384);
					*buf++ = polarity[r[ch]];//(int)((r[ch] ? l_value : -l_value));
					*buf++ = polarity2[r[ch]];//(int)((r[ch] ? r_value : -r_value));
				}
			
			}
			else
			{volatile int l_value;
				lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
							max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
				lvol = lvol-60;
				if (lvol < 0) lvol = 0;
				lvol = vol_tbl[lvol];

				l_value=(10*702*lvol)>>DESPL_S;
				polarity[0]=l_value;polarity[1]=-l_value;
				for (dwPos = 0; dwPos < dwSize; dwPos++)
				{
					k[ch] += 3000+(Np<<9);
					t = k[ch] / (unsigned)ds_nSampleRate;
					if (t >= 1)
					{
						r[ch] = mseq(&rand_val[ch]);
						k[ch] -= ds_nSampleRate*t;
					}
					*buf++ = polarity[r[ch]]; //(int)((r[ch] ? l_value : -l_value));
				}
			}
			return;
		}

		for (i = 0; i < 32; i++)
			wave[i] = ((short)io.wave[ch][i]-16)*702;

		Tp = io.PSG[ch][2]+((unsigned)io.PSG[ch][3]<<8);
		if (Tp == 0)
		{
			for (dwPos = 0; dwPos < dwSize; dwPos++)
				*buf++ = 0;
			return;
		}

		if (ds_nChannels == 2)
		{
			lvol = ((io.psg_volume>>3)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]>>3)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = vol_tbl[lvol];
			rvol = ((io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) + ((io.PSG[ch][5]<<1)&0x1E);
			rvol = rvol-60;
			if (rvol < 0) rvol = 0;
			rvol = vol_tbl[rvol];
			for (dwPos = 0; dwPos < dwSize; dwPos += 2)
			{
				*buf++ = (int)(((int)(short)wave[n[ch]]*lvol)>>DESPL_S);
				*buf++ = (int)(((int)(short)wave[n[ch]]*rvol)>>DESPL_S);
				k[ch] += N*1118608/Tp;
				t = k[ch] / (10*(unsigned)ds_nSampleRate);
				n[ch] = (n[ch]+t)%N;
				k[ch] -= 10*ds_nSampleRate*t;
			}
		}
		else
		{
			lvol = max((io.psg_volume>>3)&0x1E, (io.psg_volume<<1)&0x1E) + (io.PSG[ch][4]&0x1F) +
						max((io.PSG[ch][5]>>3)&0x1E, (io.PSG[ch][5]<<1)&0x1E);
			lvol = lvol-60;
			if (lvol < 0) lvol = 0;
			lvol = vol_tbl[lvol];
			for (dwPos = 0; dwPos < dwSize; dwPos++)
			{
				*buf++ = ((int)((int)(short)wave[n[ch]]*lvol)>>DESPL_S);
				k[ch] += N*1118608/Tp;
				t = k[ch] / (10*(unsigned)ds_nSampleRate);
				n[ch] = (n[ch]+t)%N;
				k[ch] -= 10*ds_nSampleRate*t;
			}
		}
	}
}


